//LITEWTFSONIC MAIN LUA FILE

freeslot("MT_WTFSONIC","MT_WTFSONCA","MT_WTFSONC3","MT_WTFSONCP","MT_THROWRI","MT_THROWRH") //WTFNPC types and currently used ring types

local wtfenable = 1
//Are WTFNPCs enabled? (can be used to hide the presence of this mod)
//0-WTFNPC spawning disabled, 1-WTFNPC spawning enabled (default)
//WTFNPCs will stop/start spawning after a new level is loaded

local defaultwtfnpc = MT_WTFSONIC
//Default WTFNPC type (wtf_objtype changes this)

local cwtfdiff = 2
//Default difficulty value (normal)
local diff = cwtfdiff
//Difficulty: 0-Very Easy, 1-Easy, 2-Normal, 3-Hard, 4-Very Hard, 5-Hell
//0-Enemies dont hurt you in any way, but are invincible
//1-Enemies don't shoot rings at you
//2-Classic enemy behaviour
//3-Enemies fire rings more rapidly
//4-Like Hard but enemies are invincible and they ALWAYS hurt you if you touch them
//5-Like Very Hard but enemies shoot 3 rings at once

local cwtfcbt = 0
//IF IT'S enabled: difficulty Like Hell but the fun is doubled

local cwtfta = 1
//Default target cvar value (enabled)
local target = cwtfta
//Looking for target: 0-Disabled, 1-Enabled
//Only works when AI is turned on and NPCs are moving

local cwtfskin = 0
//Default skin cvar value (all)
local skin = cwtfskin
// 0-All skins, 1-Sonic Only, 2-Tails only, 3-Knuckles Only

local cwtfai = 0
//Default AI cvar value
local ai = cwtfai
// 0-AI disabled, 1-AI enabled

local cwtfmode = 0
//Special 47 Mode
local mode = cwtfmode
// 0-Disabled, 1-Enabled

local cwtfcsts = false
//Are Custom skins allowed (by default false -- setting it to true fills skin list string)
//True or false
local custsstr = ""
local custstab = {}
//Custom skin list (string and table)
//The table loads ALL skins (except 'supsonic' skin)

//Synchronize the variables to prevent synch failures
addHook("NetVars", function(net)
	wtfenable = net(wtfenable)
	cwtfdiff = net(cwtfdiff)
	cwtfta = net(cwtfta)
	cwtfskin = net(cwtfskin)
	cwtfai = net(cwtfai)
	cwtfmode = net(cwtfmode)
	cwtfcsts = net(cwtfcsts)
	custsstr = net(custsstr)
	custstab = net(custstab)
	cwtfcbt = net(cwtfcbt)
	defaultwtfnpc = net(defaultwtfnpc)
end)

local function loadcustomskins(p)
	custsstr = ""
	custstab = {}
	for sk in skins.iterate
		if custsstr != ""
			custsstr = custsstr..","
		end
		if sk.name == "sonic" or sk.name == "tails" or sk.name == "knuckles" or sk.name == "amy" or sk.name == "fang" or sk.name == "metalsonic" //LITE: modified
			CONS_Printf(p,"Added default skin: "..sk.name)
			table.insert(custstab,sk.name)
			continue
		elseif sk.name == "supsonic"
			continue
		end
		CONS_Printf(p,"Added custom skin: "..sk.name)
		table.insert(custstab,sk.name)
		custsstr = custsstr..sk.name
	end
end

local function compareskname(name)
	if type(name) != "string" or #custstab < 1
		return false
	end
	for k,v in ipairs(custstab)
		if string.lower(v) == string.lower(name)
			return true
		end
	end
	return false
end

local function wtfspawn(p, npct, tries, randpos)
	tries = tonumber(tries)
	if not tries then tries = 1 end
	if tries < 1 then tries = 1 elseif tries > 5000 then tries = 5000 end
	local posoffset = 64*FRACUNIT
	if tries > 500 then CONS_Printf(p,"I hope your PC can handle this...") end
	if npct == "normal" or npct == "1337"
		for f = 1,tries do 
			if randpos then posoffset = (P_RandomFixed()+1-FRACUNIT/2)*100 end
			local wtfsonic = P_SpawnMobj(p.mo.x + posoffset, p.mo.y + posoffset, p.mo.z, MT_WTFSONIC)
			if wtfsonic then wtfsonic.wtfspawn = true; wtfsonic.flags = $1 & ~MF_SOLID end
		end
		CONS_Printf(p,"Spawned WTFNPC 1337 (NORMAL) "..tostring(tries).." times")
	elseif npct == "stationary" or npct == "1338"
		for f = 1,tries do 
			if randpos then posoffset = (P_RandomFixed()+1-FRACUNIT/2)*100 end
			local wtfsonic = P_SpawnMobj(p.mo.x + posoffset, p.mo.y + posoffset, p.mo.z, MT_WTFSONCA)
			if wtfsonic then wtfsonic.wtfspawn = true; wtfsonic.flags = $1 & ~MF_SOLID end
		end
		CONS_Printf(p,"Spawned WTFNPC 1338 (STATIONARY) "..tostring(tries).." times")
	elseif npct == "flying" or npct == "1339"
		for f = 1,tries do 
			if randpos then posoffset = (P_RandomFixed()+1-FRACUNIT/2)*100 end
			local wtfsonic = P_SpawnMobj(p.mo.x + posoffset, p.mo.y + posoffset, p.mo.z, MT_WTFSONC3)
			if wtfsonic then wtfsonic.wtfspawn = true; wtfsonic.flags = $1 & ~MF_SOLID end
		end
		CONS_Printf(p,"Spawned WTFNPC 1339 (FLYING) "..tostring(tries).." times")
	elseif npct == "peaceful" or npct == "1347"
		for f = 1,tries do 
			if randpos then posoffset = (P_RandomFixed()+1-FRACUNIT/2)*100 end
			local wtfsonic = P_SpawnMobj(p.mo.x + posoffset, p.mo.y + posoffset, p.mo.z, MT_WTFSONCP)
			if wtfsonic then wtfsonic.wtfspawn = true; wtfsonic.flags = $1 & ~MF_SOLID end
		end
		CONS_Printf(p,"Spawned WTFNPC 1347 (PEACEFUL) "..tostring(tries).." times")
	else
		CONS_Printf(p,"wtf_spawn <type> (amount)")
		CONS_Printf(p,"Valid types are: ")
		CONS_Printf(p,"'normal' or '1337' - normal WTFNPC")
		CONS_Printf(p,"'stationary' or '1338' - stationary WTFNPC")
		CONS_Printf(p,"'flying' or '1339' - flying WTFNPC")
		CONS_Printf(p,"'peaceful' or '1347' - peaceful WTFNPC")
	end
end

//LITE: MODIFIED
COM_AddCommand("wtf_skin", function(p, skin)
	if skin == "0" or skin == "all"
		cwtfskin = 0
		CONS_Printf(p,"WTFSkin = all")
	elseif skin == "1" or skin == "sonic"
		cwtfskin = 1
		CONS_Printf(p,"WTFSkin = Sonic")
	elseif skin == "2" or skin == "tails"
		cwtfskin = 2
		CONS_Printf(p,"WTFSkin = Tails")
	elseif skin == "3" or skin == "knuckles"
		cwtfskin = 3
		CONS_Printf(p,"WTFSkin = Knuckles")
	elseif skin == "4" or skin == "amy"
		cwtfskin = 4
		CONS_Printf(p,"WTFSkin = Amy")
	elseif skin == "5" or skin == "fang"
		cwtfskin = 5
		CONS_Printf(p,"WTFSkin = Fang")
	elseif skin == "6" or skin == "metalsonic"
		cwtfskin = 6
		CONS_Printf(p,"WTFSkin = Metal Sonic")
	elseif skin == "7" or skin == "oldtrio" or skin == "2.1trio"
		cwtfskin = 7
		CONS_Printf(p,"WTFSkin = 2.1 Trio")
	elseif cwtfcsts == true and compareskname(skin) == true
		cwtfskin = skin
		CONS_Printf(p,"WTFSkin (CUSTOM) = "..skin)
	else
		CONS_Printf(p,"Current value = " .. tostring(cwtfskin))
		CONS_Printf(p,"0-All skins, 1-Sonic Only, 2-Tails only, 3-Knuckles Only")
		CONS_Printf(p,"4-Amy only, 5-Fang Only, 6-Metal Sonic only, 7-2.1 Trio")
		if cwtfcsts == true and custsstr != ""
			CONS_Printf(p,"Custom skins: "..custsstr)
		end
	end
end, 1)

COM_AddCommand("wtf_difficulty", function(p, diff)
	if diff == "0" or diff == "very easy"
		cwtfcbt = 0
		cwtfdiff = 0
		CONS_Printf(p,"difficulty = very easy")
	elseif diff == "1" or diff == "easy"
		cwtfcbt = 0
		cwtfdiff = 1
		CONS_Printf(p,"difficulty = easy")
	elseif diff == "2" or diff == "normal"
		cwtfcbt = 0
		cwtfdiff = 2
		CONS_Printf(p,"difficulty = normal")
	elseif diff == "3" or diff == "hard"
		cwtfcbt = 0
		cwtfdiff = 3
		CONS_Printf(p,"difficulty = hard")
	elseif diff == "4" or diff == "very hard"
		cwtfcbt = 0
		cwtfdiff = 4
		CONS_Printf(p,"difficulty = very hard")
	elseif diff == "5" or diff == "hell"
		cwtfcbt = 0
		cwtfdiff = 5
		CONS_Printf(p,"difficulty = Hell")
	elseif diff == "6" or diff == "cbt"
		cwtfdiff = 5
		cwtfcbt = 1
		CONS_Printf(p,"difficulty = CBT")
		CONS_Printf(p,"Double the WTFNPC, double the fun")
	else
		if cwtfcbt == 1 then CONS_Printf(p,"Current value = 6")
		else CONS_Printf(p,"Current value = " .. tostring(cwtfdiff)) end
		CONS_Printf(p,"0-Very Easy, 1-Easy, 2-Normal, 3-Hard, 4-Very Hard, 5-Hell, 6-CBT")
	end
end, 1)

COM_AddCommand("wtf_ai", function(p, ai)
	if ai == "0" or ai == "off"
		cwtfai = 0
		CONS_Printf(p,"WTFNPC AI Off")
	elseif ai == "1" or ai == "on"
		cwtfai = 1
		CONS_Printf(p,"WTFNPC AI On")
	elseif cwtfai == 1
		CONS_Printf(p,"WTFNPC AI is enabled (1)")
	else
		CONS_Printf(p,"WTFNPC AI is disabled (0)")
	end
end, 1)

COM_AddCommand("wtf_target", function(p, target)
	if target == "0" or target == "off"
		cwtfta = 0
		CONS_Printf(p,"WTFNPC looking for target Off")
	elseif target == "1" or target == "on"
		cwtfta = 1
		CONS_Printf(p,"WTFNPC looking for target On")
	elseif cwtfta == 1
		CONS_Printf(p,"WTFNPC looking for target is enabled (1)")
	else
		CONS_Printf(p,"WTFNPC looking for target is disabled (0)")
	end
end, 1)

COM_AddCommand("wtf_spawn", function(p, npct, tries)
	wtfspawn(p,npct,tries,true)
end, 1)

COM_AddCommand("wtf_47", function(p, mode)
	if mode == "on" or mode == "1"
		cwtfdiff = -1
		cwtfmode = 1
		cwtfcbt = 0
		CONS_Printf(p,"47 Mode enabled. Enjoy!")
	elseif mode == "off" or mode == "0"
		cwtfdiff = 2
		cwtfmode = 0
		CONS_Printf(p,"47 Mode disabled.")
	else
		CONS_Printf(p,"Current value = " .. tostring(cwtfmode))
		CONS_Printf(p,"'on' or '1' - Enable 47 Mode")
		CONS_Printf(p,"'off' or '0' - Disable 47 Mode")
	end
end, 1)

COM_AddCommand("wtf_customskins", function(p, csk)
	if csk == "on" or csk == "1"
		cwtfcsts = true
		loadcustomskins(p)
		CONS_Printf(p,"Custom skins enabled")
	elseif csk == "off" or csk == "0"
		cwtfcsts = false
		custsstr = ""
		custstab = {}
		CONS_Printf(p,"Custom skins disabled")
	else
		local showcsk = "off"
		if cwtfcsts == true
			showcsk = "on"
		end
		CONS_Printf(p,"Current value = " .. showcsk)
		CONS_Printf(p,"'on' or '1' - Enable custom skins")
		CONS_Printf(p,"'off' or '0' - Disable custom skins")
	end
end, 1)

COM_AddCommand("wtf_enable", function(p, ena)
	if ena == "yes" or ena == "1"
		wtfenable = 1
		CONS_Printf(p,"WTFNPCs enabled. They will spawn after a new map is loaded.")
	elseif ena == "no" or ena == "0"
		wtfenable = 0
		CONS_Printf(p,"WTFNPCs disabled. You want to hide this mod, eh?")
		CONS_Printf(p,"Normal enemies will spawn after a new map is loaded")
	else
		local showena = "off"
		if wtfenable == 1
			showena = "on"
		end
		CONS_Printf(p,"Current value = " .. showena)
		CONS_Printf(p,"'yes' or '1' - Enable WTFNPCs")
		CONS_Printf(p,"'no' or '0' - Disable WTFNPCs")
	end
end, 1)

COM_AddCommand("wtf_objtype", function(p, wtype)
	if wtype == nil
		wtype = ""
	end
	if wtype == "1337" or string.lower(wtype) == "normal" then
		defaultwtfnpc = MT_WTFSONIC
		CONS_Printf(p,"WTFNPC set to type 1337 - NORMAL")
	elseif wtype == "1338" or string.lower(wtype) == "stationary" then
		defaultwtfnpc = MT_WTFSONCA
		CONS_Printf(p,"WTFNPC set to type 1338 - STATIONARY")
	elseif wtype == "1339" or string.lower(wtype) == "flying" then
		defaultwtfnpc = MT_WTFSONC3
		CONS_Printf(p,"WTFNPC set to type 1339 - FLYING")
	elseif wtype == "1347" or string.lower(wtype) == "peaceful" then
		defaultwtfnpc = MT_WTFSONCP
		CONS_Printf(p,"WTFNPC set to type 1347 - PEACEFUL")
	else
		local showwtype = "off"
		if defaultwtfnpc == MT_WTFSONIC then
			showwtype = "1337 (NORMAL)"
		elseif defaultwtfnpc == MT_WTFSONCA then
			showwtype = "1338 (STATIONARY)"
		elseif defaultwtfnpc == MT_WTFSONC3 then
			showwtype = "1339 (FLYING)"
		elseif defaultwtfnpc == MT_WTFSONCP then
			showwtype = "1347 (PEACEFUL)"
		else
			showwtype = "unknown type"
		end
		CONS_Printf(p,"Current value = " .. showwtype)
		CONS_Printf(p,"'normal' or '1337' - normal WTFNPC")
		CONS_Printf(p,"'stationary' or '1338' - stationary WTFNPC")
		CONS_Printf(p,"'flying' or '1339' - flying WTFNPC")
		CONS_Printf(p,"'peaceful' or '1347' - peaceful WTFNPC with AI")
	end
end, 1)

function A_CheckWSkin(actor, var1, var2)
	if cwtfskin == var1
		actor.state = var2
	else
		return
	end
end

//Check AI, but always use AI for peaceful WTFNPCs
function A_CheckWAi(actor, var1, var2)
	if cwtfai == var1 or actor.type == MT_WTFSONCP then
		actor.state = var2
	else
		return
	end
end

function A_CheckWTarget(actor, var1, var2)
	if cwtfta == var1
		actor.state = var2
	else
		return
	end
end

function A_CheckWDiff(actor, var1, var2)
	if cwtfdiff == var1
		actor.state = var2
	else
		return
	end
end

function A_SetRS(actor, var1)
	actor.info.raisestate = var1
end

function A_SetSpeed(actor, var1)
	actor.info.speed = var1
end

function A_SetHealth(actor, var1)
	actor.health = var1
end

function A_SetSeeSound(actor, var1)
	actor.info.seesound = var1
end

function A_SetDamage(actor, var1)
	actor.info.damage = var1
end

function A_SetHealthAdv(actor, var1, var2)
	if var1 == 0
		actor.health = var2
	elseif var1 == 1
		actor.health = actor.health + var2
	elseif var1 == 2
		actor.health = actor.health - var2
	elseif var1 == 3
		actor.health = actor.health * var2
	elseif var1 == 4
		if var2 == 0
			actor.health = actor.health
		else
			actor.health = actor.health / var2
		end
	end
end

function A_ChangeColorRandom(actor)
	local col=P_RandomRange(1,#skincolors-1)
	actor.color=col
end

function A_CheckCurrentSkin(actor, var1, var2)
	if var1 == 1
		if actor.skin == "sonic"
			actor.state = var2
		end
	elseif var1 == 2
		if actor.skin == "tails"
			actor.state = var2
		end	
	elseif var1 == 3
		if actor.skin == "knuckles"
			actor.state = var2
		end
	elseif var1 == 4
		if actor.skin == "amy"
			actor.state = var2
		end
	elseif var1 == 5
		if actor.skin == "fang"
			actor.state = var2
		end
	elseif var1 == 6
		if actor.skin == "metalsonic"
			actor.state = var2
		end
	//LITE: MODIFIED
	end
end

function A_SetInvincibility(actor, var1)
	if var1 == 1
		actor.flags = actor.flags & ~MF_SHOOTABLE
		actor.flags = actor.flags & ~MF_SPECIAL
		actor.flags2 = actor.flags2 | MF2_FRET
	elseif var1 == 0
		actor.flags = actor.flags | MF_SHOOTABLE
		actor.flags = actor.flags | MF_SPECIAL
		actor.flags2 = actor.flags2 & ~MF2_FRET
	end
end

//LITE: MODIFIED
function A_SetSkin(mo, var1)
	if var1 == 0
		mo.skin = "sonic"
	elseif var1 == 1
		mo.skin = "tails"
	elseif var1 == 2
		mo.skin = "knuckles"
	elseif var1 == 3
		mo.skin = "amy"
	elseif var1 == 4
		mo.skin = "fang"
	elseif var1 == 5
		mo.skin = "metalsonic"
	end
end

function A_WtfDiff(mo)
	if mo.dfset == cwtfdiff or not (mo.flags & MF_ENEMY) then
		return
	end
	if mo.info.speed < 0 and cwtfmode == 0 then mo.info.speed = -$1 end //Now it's possible to leave 47 Mode
	mo.flags = $1 | MF_SPECIAL
	mo.flags = $1 & ~MF_PAIN
	mo.flags2 = $1 & ~MF2_FIRING
	if cwtfdiff == 0
		mo.flags = mo.flags & ~MF_SPECIAL
		mo.info.raisestate = S_NULL
	elseif cwtfdiff == 1
		mo.info.raisestate = S_NULL
	elseif cwtfdiff == 2
		mo.info.raisestate = MT_THROWRI
	elseif cwtfdiff == 3
		//Nothing
	elseif cwtfdiff == 4 or cwtfdiff == 5
		mo.flags = mo.flags | MF_PAIN
		if cwtfcbt == 1 and not mo.wtfcbt then
			local doubled = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height+2*FRACUNIT,mo.type)
			if doubled then 
				doubled.wtfcbt = true
				doubled.angle = mo.angle
				doubled.momx = P_RandomRange(-4,4)*FRACUNIT
				doubled.momy = P_RandomRange(-4,4)*FRACUNIT
				if doubled.type != MT_WTFSONC3 then doubled.momz = 2*FRACUNIT end
			end
		end
	elseif cwtfdiff == -1
		mo.flags = mo.flags & ~MF_SPECIAL
		mo.info.raisestate = S_NULL
		if mo.info.speed >= 0 then mo.info.speed = -mo.info.speed end
	end
	mo.wtfcbt = true
	mo.dfset = cwtfdiff
end

function A_WtfSetup(mo)
	if mo.wtfsetup then
		return
	end
	local skinnum = 0
	if type(cwtfskin) == "string"
		if compareskname(cwtfskin) == true
			mo.skin = cwtfskin
		else
			mo.skin = "sonic"
		end
		mo.color=P_RandomRange(1,#skincolors-1)
		mo.wtfsetup = true
		return
	end
	if cwtfskin == 0
		if cwtfcsts == true and #custstab > 0
			local numx = P_RandomRange(1,#custstab)
			mo.skin = custstab[numx]
			mo.color=P_RandomRange(1,#skincolors-1)
			mo.wtfsetup = true
			return
		else
			skinnum = P_RandomRange(0,5)
		end
	elseif cwtfskin == 1
		skinnum = 0
	elseif cwtfskin == 2
		skinnum = 1
	elseif cwtfskin == 3
		skinnum = 2
	elseif cwtfskin == 4
		skinnum = 3
	elseif cwtfskin == 5
		skinnum = 4
	elseif cwtfskin == 6
		skinnum = 5
	elseif cwtfskin == 7
		skinnum = P_RandomRange(0,2) //LITE: MODIFIED
	end
	A_SetSkin(mo,skinnum)
	mo.color=P_RandomRange(1,#skincolors-1)
	mo.wtfsetup = true
end

function A_MoveAbsRAng(actor,var1,var2)
	P_InstaThrust(actor, actor.angle+FixedAngle(var1*FRACUNIT), FixedMul(var2*FRACUNIT, actor.scale))
end

function A_WTFRingColor(actor)
	actor.color = SKINCOLOR_SILVER
end

function A_WTFLook(actor,var1,var2)
	if not cwtfta or actor.type == MT_WTFSONCP then return end
	A_Look(actor,var1,var2)
end

function A_WtfXmSetup(actor)
	actor.color = P_RandomRange(1,#skincolors-1)
end

function A_WTFTurretFire(actor,var1,var2)
	A_TurretFire(actor,var1,var2)
end

function A_WTFShootBullet(actor)
	A_ShootBullet(actor)
end

local function wtfreplace(mo)
	if (mo.flags & MF_ENEMY or mo.type == MT_TURRET) and (mo.info.doomednum < 1336 or mo.info.doomednum > 1350) then
		if wtfenable then
			local wtfnpc = P_SpawnMobjFromMobj(mo,0,0,0,defaultwtfnpc)
			if not wtfnpc then return end
			if mo.flags2 & MF2_OBJECTFLIP then wtfnpc.flags2 = $1 | MF2_OBJECTFLIP end
			if mo.flags2 & MF2_AMBUSH then wtfnpc.flags2 = $1 | MF2_AMBUSH end
			wtfnpc.angle = mo.angle
			mo.state = S_NULL
		end
	elseif mo.dfset and mo.dfset != cwtfdiff and (mo.info.doomednum >= 1336 and mo.info.doomednum <= 1350) then
		A_WTFDiff(mo)
	end
end

//Real-Time WTFReplacement
addHook("MobjThinker", function(mo)
	if mo.wtfsetup then A_WtfDiff(mo) else wtfreplace(mo) end
end)

addHook("MobjThinker", function(mo)
	if cwtfcbt and mapheaderinfo[gamemap].bonustype < 1 then mo.state = S_NULL end
end,MT_FLINGRING)

//WTFReplacement replacement
addHook("MapLoad",function(mapnum)
	for mo in mobjs.iterate()
		wtfreplace(mo)
	end
end)

addHook("MobjDamage", function(target,inflictor,source,damage,damagetype) //WTFNPC knockback
	if target.wtfsetup and target.health > 0 then
		if not inflictor then return end
		inflictor.momx = -inflictor.momx
		inflictor.momy = -inflictor.momy
	end
end)

addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing.wtfspawn and thing.wtfspawn then return false end
end,MT_WTFSONIC)

addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing.wtfspawn and thing.wtfspawn then return false end
end,MT_WTFSONCA)

addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing.wtfspawn and thing.wtfspawn then return false end
end,MT_WTFSONC3)